/* The usual way compiler handle virtual
functions is to add a hidden member to each object.
The hidden holds a pointer to an array of function
addresses.  Such an array is usually termed a "vertual function table"
(vtbl) which holds the address of all the virtual
function for that class.  An object of a derived class contains a pointer
to a separate table of addresses.  If a derived class provides a new
definition of a virtual function, the vtbl holds
the address of the new function.

When you call a virtual function, the program looks at the vtbl address
stored in an object and goes to the corersponding
talbe of function addresses.  If you use the
first virtual function defined in the class declaration, the program uses
the first function address in the array and
exectues the function that has that address.
If you use the third virtual function in the class declaration
the program uses the function whose address is in the third element of
the array.

This is the overhead for virtual function with dynamic
binding:
1. Each object has its size increased by the amount needed to hold an address.
2. For each class, the compiler creats a talbe of address of virtual functions.
3. For each function call, there's an extra step of going to a table to look
up an address.

Note: Constructors can't be virtual.  A derived class
constructor uses the base0class contructor and builds
on it, but the sequence of constructors is distinct from the inheritance mechanism.
Thus, a derived class doesn't inherit the base0-class constructors, so usually
there's not much point to making them virtual anyway.

Destructors should be virtual.  Normally, you should
provide a base class with a virtual destructor even if
the class doesn't need a destructor.

Friends are not class members and so can't be virtual.



*/
